﻿Type=StaticCode
Version=2.52
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

Public Sub CheckAFM(sAFM As String) As Boolean
' Validate an AFM number
' Pre: sAFM = string containing the AFM
' Post: True if sAFM is a valid AFM, False otherwise
' NOTE: This algorithm does NOT check if the AFM actually exists, only if it is a valid number!
' Usage Example: a=CheckAFM("012345678")->a=False
' Yiannis Papadopoulos <www.yiapap.com> 2004
	Dim iChar, iPower, iSum As Int
	Dim btRem As Byte
	Dim i As Byte

	If sAFM  = "" OR sAFM.Length <> 9 Then
		Return False
	End If

	iSum = 0

	For i = 0 To sAFM.Length - 2
		If Asc(sAFM.SubString2(i, i + 1)) < 48 OR Asc(sAFM.SubString2(i, i + 1)) > 57 Then
			Return False
		End If
		iChar = sAFM.SubString2(i, i + 1)
		iPower = Power(2, (sAFM.Length - (i + 1)))
		iSum = iSum + (iChar * iPower)
	Next

	If iSum = 0 Then
		Return False
	Else
		btRem = iSum Mod 11

		If sAFM.SubString(sAFM.Length - 1) = btRem OR (btRem = 10 AND sAFM.SubString(sAFM.Length - 1) = 0) Then 
			Return True
		End If
	End If
End Sub